Ext
		.regApplication({
			name : "impianti",

			initmap : function() {
				Ext.dispatch({
					controller : 'mappa',
					action : 'initmap'
				});
			},

			init : function() {

				impianti.mask = new Ext.LoadMask(Ext.getBody(), {
					hidden : false,
					msg : "Caricamento in corso..."
				}),

				// Stores Init

				impianti.goToDetail = function(id, typr) {
					switch (typr) {
					case 'a':
						this.store = impianti.storeload;

						impianti.currentimpianto = this.store.getAt(id);
						impianti.detailau.update(impianti.currentimpianto.data);
						impianti.mainpanel.setActiveItem('ricercaviewid');
						impianti.ricercaview.setActiveItem('detailauid', {
							type : 'slide',
							direction : 'left'
						});
						break;
					case 'p':
						break;
					}
				};

				// views init

				impianti.ricercaview = new Ext.Panel({
					id : 'ricercaviewid',
					iconCls : 'search',
					fullscreen : true,
					title : 'Ricerca Impianti',
					layout : 'card',
					items : [ impianti.ricerca, impianti.ricercalist, impianti.detailau ],
				});

				impianti.mapPanel = new Ext.Panel({
					id : 'mapid',
					title : "Mappa",
					fullscreen : true,
					layout : {
						type : 'vbox',
						align : 'stretch'
					},
					iconCls : 'csimap',
					dockedItems : [],
					items : []
				});

				impianti.mainpanel = new Ext.TabPanel({
					id : 'mainid',
					fullscreen : true,
					cardSwitchAnimation : false,
					tabBar : {
						dock : 'bottom',
						layout : {
							pack : 'center'
						}
					},
					listeners : {
						cardswitch : function(t, n, o, i, a) {
							if (impianti.mappamon != undefined) {
								if (n.id != 'mapid') {
									impianti.mappamon.hide();
								} else {
									impianti.mappamon.show();
									if (impianti.infowindow == null) {
										if (impianti.userloc.coords == undefined) {
											Ext.Msg.alert('Errore', 'Impossibile rilevare la tua posizione', Ext.emptyFn);
										} else {
											impianti.mappamon.map.panTo(impianti.userloc.coords);
										}
									}
								}
							}
						},
					},
					dockedItems : [ {
						dock : 'top',
						xtype : 'button',
						height : Ext.is.Phone ? 52 : 104,
						cls : 'x-banner-csi-top',
						handler : function() {
							impianti.splashview.setActiveItem('menuid');
						}
					} ],
					items : [ impianti.ricercaview, impianti.mapPanel ]
				});

				impianti.menu = new Ext.Panel({
					id : 'menuid',
					cls : 'csi-home',
					fullscreen : true,
					layout : {
						type : 'vbox',
						align : 'center',
						pack : 'bottom'
					},
					defaults : {
						xtype : 'button',
						cls : 'csi-button',
						width : Ext.is.Phone ? 250 : 300,
						margin : 10,
					},
					items : [ {
						flex : Ext.is.Phone ? 4 : 5,
						xtype : 'spacer'
					}, {
						flex : 1,
						html : '<img src="images/search1_w.png">&nbsp;&nbsp;Ricerca Impianti',
						handler : function() {
							Ext.dispatch({
								controller : 'ricerca',
								action : 'ricerca'
							});
						},

					}, {
						flex : 1,
						html : '<img src="images/locate4_w.png">&nbsp;&nbsp;Mappa',
						handler : function() {
							Ext.dispatch({
								controller : 'mappa',
								action : 'mappa'
							});
						},
					}, {
						flex : 1,
						xtype : 'spacer'
					} ],
					dockedItems : [ {
						dock : 'bottom',
						xtype : 'button',
						height : Ext.is.Phone ? 44 : 88,
						cls : 'x-page-csi-bottom',
						handler : function() {
							impianti.splashview.setActiveItem('infoid', {
								type : 'slide',
								direction : 'up'
							});
						},
					} ]
				});

				impianti.info = new Ext.Panel(
						{
							id : 'infoid',
							scroll : 'vertical',
							dockedItems : [ {
								dock : 'top',
								xtype : 'toolbar',
								title : 'Informazioni',
								items : [ {
									xtype : 'spacer'
								}, {
									text : 'fine',
									ui : 'action',
									handler : function() {
										impianti.splashview.setActiveItem('menuid', {
											type : 'slide',
											direction : 'left'
										});
									}
								} ]
							} ],
							items : [ {
								xtype : 'panel',
								layout : 'vbox',
								fullscreen : true,
								cls : 'csi-info',
								items : [
										{
											flex : 3,
										},
										{
											flex : 3,
											scroll : 'vertical',
											html : '<div class="info-text">Stai cercando una piscina a Torino? Vuoi sapere dove andare a pattinare? Con "Sport a Torino" puoi localizzare tutti gli impianti sportivi della Citt&agrave;.<BR />'
													+ 'Scegli la disciplina sportiva che vuoi praticare e accedi all&apos;elenco degli impianti dove &egrave; possibile praticarla.<br />'
													+ 'Con una comoda mappa puoi anche visualizzare gli impianti sportivi pi&ugrave; vicini al luogo dove ti trovi.',
										}, {
											flex : 1
										} ]
							} ]
						});

				impianti.splashview = new Ext.Panel({
					fullscreen : true,
					title : 'Splash',
					layout : 'card',
					items : [ impianti.menu, impianti.mainpanel, impianti.info ],
				});

			},

		});

Ext.setup({

	onReady : function() {
		impianti.init();
		impianti.mask.show();
		impianti.initmap();
		
		if(Ext.is.Phone) impianti.mappamon.setHeight(400);

		impianti.storeload = Ext.getStore('ImpiantiStoreLoad');
		impianti.currentpage = 0;
		impianti.availablepages = 1;
		impianti.storeload.on('load', impianti.onloadlist);

		impianti.storediscipline = Ext.getStore('DisciplineStore');
		impianti.displinaselectfieldoptions = new Array({
			value : '',
			text : ''
		});
		impianti.storediscipline.on('load', function() {
			for ( var d = 0; d < impianti.storediscipline.data.items.length; d++) {
				impianti.displinaselectfieldoptions[d + 1] = {
					value : impianti.storediscipline.data.items[d].data.id,
					text : impianti.storediscipline.data.items[d].data.descrizione
				};
			}
			var tmp = Ext.getCmp('disciplinaid');
			tmp.setOptions(impianti.displinaselectfieldoptions);

			impianti.mask.hide();
		});
		impianti.storediscipline.load();

		if (Ext.is.Phone ? navigator.network.connection.type == Connection.NONE : navigator.onLine == 'offline') {
			Ext.Msg.alert('Rete', 'Attenzione problemi di connettivit&agrave;  L\'applicazione non pu&ograve; funzionare!',
					Ext.emptyFn);
		}
	}
});
