Ext.regController("mappa", {

	maprendervicini : function(d) {

		if (impianti.infowindow)
			impianti.infowindow.close();
		this.data = impianti.storeload.data.items;

		for ( var i = 0; i < impianti.markerArray.length; i++) {
			if (impianti.markerArray[i] != undefined) {
				impianti.markerArray[i].setMap(null);
			}
			impianti.markerArray[i] = undefined;
		}
		impianti.markerArray = new Array();

		for ( var i = 0; i < this.data.length; i++) {
			this.pos = new google.maps.LatLng(this.data[i].data.lat, this.data[i].data.lng);

			impianti.markerArray[i] = new google.maps.Marker({
				position : this.pos,
				title : this.data[i].data.titolo,
				icon : impianti.markerimage,
				shadow : impianti.markershadow,
				map : impianti.mappamon.map
			});
			this.attachMarker(impianti.markerArray[i], this.data[i].data.titolo, false, this.data[i].data.indirizzo);
		}

		//impianti.mappamon.map.panTo(this.pos);
		impianti.mask.hide();
	},

	maprender : function(data) {
		if (impianti.infowindow)
			impianti.infowindow.close();

		for ( var i = 0; i < impianti.markerArray.length; i++) {
			if (impianti.markerArray[i] != undefined) {
				impianti.markerArray[i].setMap(null);
			}
			impianti.markerArray[i] = undefined;
		}
		impianti.markerArray = new Array();

		this.pos = new google.maps.LatLng(data.data.data.lat, data.data.data.lng);

		impianti.markerArray[0] = new google.maps.Marker({
			position : this.pos,
			title : data.data.data.titolo,
			map : impianti.mappamon.map,
			icon : impianti.markerimage,
			shadow : impianti.markershadow,
		});
		this.attachMarker(impianti.markerArray[0], data.data.data.titolo, true, data.data.data.indirizzo);

		impianti.mappamon.map.panTo(this.pos);
		impianti.mask.hide();
	},

	attachMarker : function(marker, message, flag, indirizzo) {

		var iw = new InfoBubble({
			content : '<div id="content"><p>' + message + '</p><p style="font-size:70%;">' + indirizzo
					+ '</p></div>',
			shadowStyle : 1,
			padding : 10,
			margin: 10,
			backgroundColor : 'white',
			borderRadius : 5,
			arrowSize : 30,
			borderWidth : 1,
			borderColor : '#eeeeee',
			disableAutoPan : true,
			hideCloseButton : true,
			arrowPosition : 60,
			minHeight: 90,
			arrowStyle : 1
		});

		if (flag) {
			iw.open(impianti.mappamon.map, marker);
			impianti.infowindow = iw;
		}
		
		google.maps.event.addListener(marker, 'mouseup', function() {
			if (impianti.infowindow)
				impianti.infowindow.close();
			iw.open(impianti.mappamon.map, marker);
			impianti.infowindow = iw;
		});
	},

	map_rendered : function(records) {
		console.log("map rendered");
	},

	mappa : function() {
		impianti.splashview.setActiveItem('mainid');
		impianti.mainpanel.setActiveItem('mapid');

		if (impianti.userloc.coords == undefined) {
			Ext.Msg.alert('Errore', 'Impossibile rilevare la tua posizione', Ext.emptyFn);
			return;
		}
		impianti.mappamon.map.panTo(impianti.userloc.coords);
	},

	initmap : function() {

		impianti.infowindow = null;

		impianti.baseposition = new google.maps.LatLng(45.078534, 7.704043);
		impianti.deltadistance = 0.0008;

		impianti.markerArray = new Array();

		impianti.markerimage = new google.maps.MarkerImage('images/point.png', new google.maps.Size(32, 31),
				new google.maps.Point(0, 0), new google.maps.Point(16, 31));
		impianti.markershadow = new google.maps.MarkerImage('images/shadow.png', new google.maps.Size(32, 31),
				new google.maps.Point(0, 0), new google.maps.Point(16, 31));

		// Tracking Marker Image
		impianti.image = new google.maps.MarkerImage('images/Location.png', new google.maps.Size(40, 40),
				new google.maps.Point(0, 0), new google.maps.Point(16, 31));

		impianti.userloc = new Ext.plugin.GMap.Tracker({
			trackSuspended : true,
			highAccuracy : false,
			marker : new google.maps.Marker({
				position : impianti.position,
				title : 'La mia posizione',
				// shadow : impianti.shadow,
				icon : impianti.image
			})
		});
		// DEBUG force position (update false)
		// impianti.userloc.coords = impianti.baseposition;

		impianti.maptoolbar = new Ext.Toolbar({
			dock : 'top',
			xtype : 'toolbar',
			title : 'Mappa',
			defaults : {
				iconMask : true
			},
			items : [ {
				xtype : 'button',
				iconCls : 'locate',
				text : 'pi&ugrave; vicini',
				handler : function() {
					if (impianti.userloc.coords == undefined) {
						Ext.Msg.alert('Errore', 'Impossibile rilevare la tua posizione', Ext.emptyFn);
						return;
					}

					// testoDaRicercare: testo cercato (like google) - String
					// accessoDisabili: se ci sono accessi per disabili -
					// Boolean
					// utilizzoDisabili: se possono praticare sport i disabili -
					// Boolena
					// refDisciplina: dinamico (il codice) - Number
					// lat: latitudine - Number
					// lng: longitudine - Number
					// distMax: distanza massima per l'estrazione espressa in
					// metri
					//  -
					// Number

					impianti.mappamon.map.panTo(impianti.userloc.coords);
					impianti.mask.show();

					var p = impianti.storeload.getProxy();
					p.url = baseurl + 'lat=' + impianti.userloc.coords.lat() + '&lng='
							+ impianti.userloc.coords.lng();

					impianti.storeload.on('load', impianti.onloadmap);
					impianti.storeload.load();

				},
			} ]
		});

		impianti.mappamon = new Ext.Map({
			hidden : true,
			fullscreen : true,
			getLocation: true,
			id : 'mapcid',
			mapOptions : {
				zoom : 16,
				disableDefaultUI : true,
				zoomControl : true,
				zoomControlOptions : {
					style : google.maps.MapTypeControlStyle.SMALL,
					position : google.maps.ControlPosition.LEFT_CENTER
				},
				mapTypeId : google.maps.MapTypeId.MAP,
			},
			plugins : [ impianti.userloc ],
		});

		impianti.mapPanel.add({
			items : impianti.mappamon
		});
		impianti.mapPanel.add({
			dockedItems : impianti.maptoolbar
		});

		google.maps.event.addListener(impianti.mappamon.map, 'mouseup', function() {
			if (impianti.infowindow)
				impianti.infowindow.close();
		});

		impianti.mask.hide();
	}
});