Ext.regController(
		"ricerca",
		{

			ricerca : function() {
				impianti.splashview.setActiveItem('mainid');
				impianti.mainpanel.setActiveItem('ricercaviewid');
				impianti.ricercaview.setActiveItem('ricercamain');
			},

			init : function() {

				impianti.detailauToolbar = new Ext.Toolbar({
					title : 'Dettaglio',
					items : [ {
						text : 'indietro',
						ui : 'back',
						handler : function() {
							impianti.ricercaview.setActiveItem('ricercalist', {
								type : 'slide',
								direction : 'right'
							});
						}
					}, {
						xtype : 'spacer'
					}, {
						xtype : 'button',
						// width : Ext.is.Phone ? 250 : 300,
						// cls : 'csi-button-mappa',
						ui : 'confirm',
						text : 'Mappa',
						handler : function() {
							 this.tmp = Ext.getCmp('mappbackid');
								if (this.tmp != undefined)
									impianti.maptoolbar.remove(this.tmp);

							impianti.maptoolbar.insert(0, {
								text : 'indietro',
								id : 'mappbackid',
								ui : 'back',
								handler : function() {
									this.tmp = Ext.getCmp('mappbackid');
									impianti.maptoolbar.remove(this.tmp);
									impianti.maptoolbar.doLayout();
									impianti.mainpanel.setActiveItem('ricercaviewid', {
										type : 'slide',
										direction : 'left'
									});
								}
							});
							impianti.maptoolbar.doLayout();
							impianti.mainpanel.setActiveItem('mapid');

							Ext.dispatch({
								controller : 'mappa',
								action : 'maprender',
								data : impianti.currentimpianto,
								index : impianti.currentricercaindex
							});
						},
					} ]
				});

				impianti.template = new Ext.XTemplate('<div class="csi-details"><h1>{titolo}</h1>',
						'<p>{indirizzo}</p>',
						'<tpl for="immagini">',
						'<img alt="nessuna immagine disponibile" src="{pathFile}"/><br>{descrizione}', '</tpl>',
						'<p><span><br>Contatti:</span><br>Tel.{telefono} - Circoscrizione {circoscrizione}</p>',
						'<tpl if="email !=\'\'"><p><span>Email:</span> {email}</p></tpl>',
						'<p><span><br>Descrizione:</span><br>{descrizione}</p>',
						'<p><span><br>Apertura impianto:<br></span>{orari}</p>',
						'<tpl if="mezzi !=\'\'"><p><span><br>Mezzi Pubblici:<br></span><br>{mezzi}</p></tpl>',
						'<br><h1>Campi disponibili</h1>',
						'<table><tr><th>Tipo impianto (Dim.)</th><th>Numero campi</th><th>Discipline</th><tr>',
						'<tpl for="campi">',
						'<tr><td>{tipo} ({dimensioni})</td><td>{numCampi}</td><td>{discipline}</td></tr>',
						'</tpl></table>', '<h1>Gestori</h1>', '<ul><tpl for="gestori">', '<li>{descrizione}</li>',
						'</tpl></ul>', '<h1>Link</h1>', '<ul><tpl for="link">',
						'<li><a href="{pathFile}">{descrizione}</a></li>', '</tpl></ul>', '</div>');

				impianti.detailau = new Ext.Panel({
					id : 'detailauid',
					scroll : 'vertical',
					tpl : impianti.template,
					dockedItems : [ impianti.detailauToolbar ],
				});

				impianti.ricercalist = new Ext.Panel(
						{
							id : 'ricercalist',
							layout : {
								type : 'vbox',
								align : 'stretch'
							},
							dockedItems : [ {
								dock : 'top',
								xtype : 'toolbar',
								title : 'Impianti',
								items : {
									text : 'indietro',
									ui : 'back',
									handler : function() {
										impianti.currentpage = 0;
										impianti.ricercaview.setActiveItem('ricercamain', {
											type : 'slide',
											direction : 'right'
										});
									}
								}
							} ],
							items : [ {
								flex : 1,
								xtype : 'list',
								id : 'ricercastorelistid',
								centered : false,
								store : Ext.getStore('ImpiantiStoreLoad'),
								itemTpl : '<img align="right" src="images/Arrow_ICO.png"><div class="csi-titolo"><strong>{titolo}</strong><div class="csi-indirizzo">{indirizzo}</div></div>',
								plugins : [ {
									ptype : 'pagingimpianti',
									autoPaging : false
								} ],

								listeners : {
									itemtap : function(view, index, item, e) {
										impianti.currentimpianto = impianti.storeload.getAt(index);
										impianti.currentricercaindex = index;
										impianti.detailau.update(impianti.currentimpianto.data);
										impianti.ricercaview.setActiveItem('detailauid', {
											type : 'slide',
											direction : 'left'
										});
									}
								}
							} ],
						});

				impianti.searchform = new Ext.form.FormPanel(
						{
							cls : 'csi-searchform',
							url : 'empty.json',
							method : 'GET',
							id : 'searchform',
							scroll : 'vertical',
							flex : 1,
							listeners : {
								exception : impianti.pageload,
								submit : impianti.pageload
							},
							items : [
									{
										xtype : 'fieldset',
										cls : 'csi-small',
										title : 'La modalit&agrave; di ricerca permette di trovare tutti gli impianti sportivi che contengono la parola o la parte di testo inserita.',
										centerd : true,
										items : [ {
											id : 'searchname',
											xtype : 'textfield',
											name : 'name',
											placeHolder : 'Ricerca impianto',
											useClearIcon : true
										}, {
											label : 'Disciplina',
											labelWidth : "30%",
											id : 'disciplinaid',
											xtype : 'selectfield',
											name : 'disciplina',
											options : []
										} ]
									}, {
										xtype : 'fieldset',
										title : 'Accessibilit&agrave;',
										items : [ {
											labelWidth : "70%",
											xtype : 'checkboxfield',
											name : 'pubblico',
											label : 'Per il pubblico',
											value : 'true'

										}, {
											labelWidth : "70%",
											xtype : 'checkboxfield',
											name : 'atleti',
											label : 'Per gli atleti',
											value : 'true'
										} ]
									}, {
										xtype : 'container',
										layout : {
											type : 'vbox',
											align : 'center'
										},
										items : [ {
											xtype : 'button',
											text : 'Cerca',
											ui : 'confirm',
											width : Ext.is.Phone ? 250 : 300,
											handler : function() {
												tmp = Ext.getCmp('searchform');
												impianti.mask.show();
												tmp.submit();
											}
										} ]
									} ]
						});

				impianti.ricerca = new Ext.Panel({
					id : 'ricercamain',
					layout : {
						type : 'vbox',
						align : 'stretch'
					},
					dockedItems : [ {
						dock : 'top',
						xtype : 'toolbar',
						title : 'Ricerca Impianti',
					} ],
					items : [ impianti.searchform ],
				});
			}
		});
