Ext.regStore(
		'DisciplineStore',
		{
			autoLoad : false,
			model : 'Discipline',
			proxy : {
				// url : 'discipline.json',
				url : disciplineurl,
				type : 'ajax',
				listeners : {
					exception : function() {
						Ext.Msg.alert('Rete', 'Errore connessione server', Ext.emptyFn);
					}
				},
				reader : {
					type : 'json',
					root : 'discipline',
				}
			}
		});

Ext.regStore('ImpiantiStoreLoad', {
	autoLoad : false,
	model : 'Impianti',
	proxy : {
		url : '',
		listeners : {
			exception : function() {
				Ext.Msg.alert('Rete', 'Errore connessione server', Ext.emptyFn);
			}
		},
		type : 'ajax',
		reader : {
			clearOnPageLoad : false,
			type : 'json',
			root : 'rs',
			read : function(response) {
				var data = response;
				if (response && response.responseText) {
					try {
						data = this.getResponseData(response);
					} catch (err) {
						Ext.Msg.alert('Rete', 'Errore connessione server', Ext.emptyFn);
					}

				}
				impianti.currentpage = data.page;
				impianti.availablepages = data.pages;
				if ((impianti.currentpage + 1) == impianti.availablepages) {
					impianti.nextpage = 0;
				} else {
					impianti.nextpage = data.page + 1;
				}
				if (data) {
					return this.readRecords(data);
				} else {
					return this.nullResultSet;
				}
			},
		}
	}
});

impianti.ListPagingPlugin = Ext.extend(Ext.util.Observable, {

	autoPaging : false,

	loadMoreText : 'Altri impianti...',

	init : function(list) {
		this.list = list;

		list.onBeforeLoad = Ext.util.Functions.createInterceptor(list.onBeforeLoad, this.onBeforeLoad, this);

		this.mon(list, 'update', this.onListUpdate, this);
	},

	onListUpdate : function() {
		if (!this.rendered) {
			this.render();
		}

		if ((impianti.currentpage + 1) != impianti.availablepages) {
			this.el.appendTo(this.list.getTargetEl());

			if (!this.autoPaging) {
				this.el.removeCls('x-loading');
			}
		}
		this.loading = false;
	},

	render : function() {
		var list = this.list, targetEl = list.getTargetEl(), html = '';

		if (!this.autoPaging) {
			html += '<div class="x-list-paging-msg">' + this.loadMoreText + '</div>';
		}

		this.el = targetEl.createChild({
			cls : 'x-list-paging' + (this.autoPaging ? ' x-loading' : ''),
			html : html + Ext.LoadingSpinner
		});

		if (this.autoPaging) {
			this.mon(targetEl.getScrollParent(), 'scrollend', this.onScrollEnd, this);
		} else {
			this.mon(this.el, 'tap', this.onPagingTap, this);
		}

		this.rendered = true;
	},

	onBeforeLoad : function() {
		if (this.loading && this.list.store.getCount() > 0) {
			this.list.loadMask.disable();
			return false;
		}
	},

	onPagingTap : function(e) {
		if (!this.loading) {
			this.loading = true;
			impianti.pageload();
			this.el.addCls('x-loading');
		}
	},

	onScrollEnd : function(scroller, pos) {
		if (pos.y >= Math.abs(scroller.offsetBoundary.top)) {
			this.loading = true;
			impianti.pageload();
		}
	}
});

Ext.preg('pagingimpianti', impianti.ListPagingPlugin);

impianti.pageload = function(form, result) {
	// impianti.store = Ext.getStore('ImpiantiStore');

	// testoDaRicercare: testo cercato (like google) - String
	// accessoDisabili: se ci sono accessi per disabili - Boolean
	// utilizzoDisabili: se possono praticare sport i disabili - Boolena
	// refDisciplina: dinamico (il codice) - Number
	// lat: latitudine - Number
	// lng: longitudine - Number
	// distMax: distanza massima per l'estrazione espressa in metri  -
	// Number

	var p = impianti.storeload.getProxy();
	var page = 0;

	if (form == undefined) {
		if ((impianti.currentpage + 1) == impianti.availablepages) {
			page = impianti.currentpage;
		} else {
			page = impianti.currentpage + 1;
		}
	}

	if (impianti.userloc.coords == undefined) {
		impianti.fullurl = baseurl + 'page=' + page;
	} else {
		impianti.fullurl = baseurl + 'lat=' + impianti.userloc.coords.lat() + '&lng='
				+ impianti.userloc.coords.lng() + '&page=' + page;
	}

	if (this.getValues != undefined) {
		impianti.searchparams = this.getValues();
	}
	impianti.fullurl += '&refDisciplina=' + impianti.searchparams.disciplina;
	if (impianti.searchparams.pubblico == 'true')
		impianti.fullurl += '&accessoDisabili=' + impianti.searchparams.pubblico;
	if (impianti.searchparams.atleti == 'true')
		impianti.fullurl += '&utilizzoDisabili=' + impianti.searchparams.atleti;
	impianti.fullurl += '&testoDaRicercare=' + escape(impianti.searchparams.name);

	var p = impianti.storeload.getProxy();
	p.url = impianti.fullurl;

	if (form == undefined) {
		Ext.data.Store.superclass.load.call(impianti.storeload, {
			addRecords : true
		});
	} else {
		impianti.storeload.load();
		// Ext.data.Store.superclass.load.call(impianti.storeload, {
		// addRecords : false
		// });
	}

	impianti.ricercaview.setActiveItem('ricercalist', {
		type : 'slide',
		direction : 'left'
	});

};

impianti.onloadmap = function() {
	Ext.dispatch({
		controller : 'mappa',
		action : 'maprendervicini',
	});

};

impianti.onloadlist = function() {
	if(impianti.storeload.data.items.length == 0) {
		Ext.Msg.alert('Info', 'Nessun impianto trovato', Ext.emptyFn);		
	}
	impianti.mask.hide();
};
